-- Image Animated by MikuAuahDark
-- Create table that holds all of the animated image
Animated={}
-- Try to create new __timerArg table. Don't create if already exists
__timerArg=__timerArg or {}

-- Create timerEx v4.1 if timerEx function isn't exists(More informaton about this LUA can be seen at timerex_desc.lua)
timerEx=timerEx or function(ms,func,count,...)
	count=count or 1
	if count==0 then count=-1 end
	local tmpfunc,id="",0
	local random=math.random
	local char=string.char
	for i=1,8 do
		local rand=random(0,2)
		if rand==0 then
			tmpfunc=tmpfunc..char(random(65,90))
		elseif rand==1 then
			tmpfunc=tmpfunc..char(random(97,112))
		else
			tmpfunc=tmpfunc..random(0,9)
		end
	end
	table.insert(__timerArg,{type(func),tmpfunc,func,{...},count})
	for n,v in pairs(__timerArg) do
		if v[2]==tmpfunc then
			id=n
			break
		end
	end
	_G[tmpfunc]=function(id)
		id=tonumber(id)
		local ta=__timerArg
		if ta[id][1]=="function" then
			ta[id].r=ta[id][3](unpack(ta[id][4]))
		elseif ta[id][1]=="string" or ta[id][1]=="number" then
			ta[id].r=loadstring("return "..ta[id][3].."(unpack(ta["..id.."][4]))")()
		end
		ta[id][5]=ta[id][5]-1
		if ta[id][5]==0 then
			_G[ta[id][2]]=nil
			ta[id]=nil
		end
	end
	timer(ms,tmpfunc,id,count)
	return id
end

-- Create freetimerEx if freetimerEx function isn't exists(More informaton about this LUA can be seen at timerex_desc.lua)
freetimerEx=freetimerEx or function(id)
	local ta=__timerArg
	if ta[id]~=nil then
		freetimer(ta[id][2],id)
		_G[ta[id][2]]=nil
		ta[id]=nil
		return true
	end
	return false
end

-- Create imageanimated function. Function that create the animated image
function imageanimated(folder,usemeta,filepattern,x,y,mode,pl,speed)
	-- Try to show it to all players if pl parameter is nil
	pl=pl or 0
	-- Create 2 local variables. filecount used to count frame in folder
	local filecount=0
	-- foldermode is used if the folder string have "/" or not. if have then it 1. otherwise, 0
	local foldermode=0
	-- Generate local function
	local function getMode(f)
		-- Try to open the file
		local temp=io.open(folder.."/"..f,"r")
		-- It's nil. Then foldermode is 1
		if temp==nil then
			-- Set variables
			foldermode=1
			-- Return new file handle
			return io.open(folder..f,"r")
		-- Then, the folder doesn't have "/" at end
		else
			-- Return current handle
			return temp
		end
	end
	-- Create local function
	local meta
	-- Check if it uses meta for settings
	if usemeta then
		-- Try to open meta.txt
		meta=getMode("meta.txt")
	end
	-- Check if meta is a file handle(not nil)
	if meta then
		-- Used internally
		local a=0
		-- Do loop for each line
		for line in meta:lines() do
			-- Add
			a=a+1
			-- Check if a is 1(filepattern is first line)
			if a==1 then
				-- Change value
				filepattern=line
			-- Check if a is 2(mode and speed is second line)
			elseif a==2 then
				-- Do one-time loop
				for m,s in line:gmatch("(%d+) (%d+)") do
					-- Set value
					mode=m
					speed=s
				end
			end
		end
		-- Close file
		meta:close()
	end
	-- Set speed to 100 if no meta is used and it's nil
	speed=speed or 100
	-- Do always loop
	while true do
		-- Add file count
		filecount=filecount+1
		-- Try to open file handle with formatted "filepattern"
		local temp=io.open(folder.."/"..filepattern:format(filecount),"r") or io.open(folder..filepattern:format(filecount),"r")
		-- Check if file is cannot opened
		if temp==nil then
			-- Decrease it
			filecount=filecount-1
			-- Break current loop
			break
		end
		-- File is exists, loop again and close the file
		temp:close()
	end
	-- Check if there is no file(frame) at folder
	if filecount==0 then
		print("\169255000000Image Animated: No files found!")
		return 0
	end
	-- Create local variable
	local iid
	-- Create a table that used to handle animated image data
	local temp={{},0,1}
	-- Foldermode checking
	if foldermode==0 then
		-- Do loop till filecount
		for i=1,filecount do
			-- Load image
			iid=image(folder.."/"..filepattern:format(i),x,y,mode,pl)
			-- Check if it cannot loaded
			if iid==0 then
				print("\169255000000Image Animated: Cannot Load "..filepattern:format(i))
				return 0
			end
			-- Set image alpha to 0
			imagealpha(iid,0)
			-- Insert image ID at table
			table.insert(temp[1],iid)
		end
	else
		-- Same as above
		for i=1,filecount do
			iid=image(folder..filepattern:format(i),x,y,mode,pl)
			if iid==0 then
				print("\169255000000Image Animated: Cannot Load "..filepattern:format(i))
				return 0
			end
			imagealpha(iid,0)
			table.insert(temp[1],iid)
		end
	end
	-- Set value
	temp[3]=1
	-- Insert data to list
	table.insert(Animated,temp)
	-- Local variable
	local id=0
	-- Do loop at Animated
	for n,v in pairs(Animated) do
		-- Check if address of 'v' is same as 'temp'
		if v==temp then
			-- It's the ID
			id=n
			-- Break current operation to destroy some lags
			break
		end
	end
	-- Something is wrong. I don't know why(If id is 0)
	if id==0 then
		print("\169255000000Image Animated: Unknown Error")
		return 0
	end
	-- Create timerEx
	temp[2]=timerEx(speed,loadstring("local n,p=0,Animated["..id.."][3] if p==#Animated["..id.."][1] then n=1 else n=p+1 end imagealpha(Animated["..id.."][1][n],1) imagealpha(Animated["..id.."][1][p],0) Animated["..id.."][3]=n"),-1)
	-- Check if there is no error at timerEx
	if temp[2]==0 then
		print("\169255000000Image Animated: timerEx Error!")
		return 0
	end
	-- Ok let's make the first frame visible
	imagealpha(temp[1][1],1)
	-- Return ID
	return id
end

-- Function that allow you to move the image
function imageanimatedpos(id,x,y,rot)
	local Animated=Animated
	if Animated[id] then
		rot=rot or 0
		for n,v in pairs(Animated[id][1]) do
			imagepos(v,x,y,rot)
		end
	end
end

-- Function that allow you to destroy animated image + timers
function freeimageanimated(i)
	if Animated[i] then
		for n,v in pairs(Animated[i][1]) do
			freeimage(v)
		end
		freetimerEx(Animated[i][2])
		Animated[i]=nil
	end
end

-- This is used to destroy all animated images + timers at roundstart
addhook("startround","destroy_animated")
function destroy_animated()
	for n,v in pairs(Animated) do
		freeimageanimated(n)
	end
end